/////////////////////////////////////////////////////////////////
//Kapitel Bibliotheken: Minim
//Mit den 1024 Werten des Zeit-Amplitude-Puffers wird bei jedem draw()-
//Befehl eine ganze Zeile gefüllt. Die Farben werden wie
//beim sketch "BufferBild" bestimmt. Für amplitude, die über level
//berechnet wird, gibt es ja nur einen Wert pro Puffer. Daher wird
//dieser Wert mit random(0.5,1.5) künstlich variiert.
/////////////////////////////////////////////////////////////////////

import ddf.minim.*;   

Minim minim;                              
AudioPlayer musik;   
int breite = 1064;//1064-2*rand: Ein Puffer-Speicherinhalt
int hoehe = 800;
int zAbstand = 15;  //Zeilenabstand
int rand = zAbstand;  // Randbreite
int aFaktor = 20;   // Amplituden-Faktor
int y = zAbstand;
int k = 0;//Pixelnummer 
int n = 0;//Nummer Pixel in einer Zeile
//effektive Anzahl zu beschreibender Pixel:
int ePixelAnzahl = int((breite-2*rand)*(hoehe-2*rand)/zAbstand);  //hier 39526              
float zeilenNummer=rand;  
float[] mixLevel,linksLevel,rechtsLevel; //Sample-Werte
float[] amplitude; //Durchschnitts-Amplitude des gesamten Puffers
float[] radius; //Für zu zeichnende Ellipsen
float[] rot, gruen,blau; 
float[] transparenz ;
float[] staerke ; 

int[] eckenAnzahl;
float[] winkel;

void setup() {
  surface.setSize(breite,hoehe);                       
  background(255);                       
  frameRate(4);
  mixLevel = new float[1024];
  linksLevel = new float[1024];
  rechtsLevel = new float[1024];
  amplitude = new float[1024];
  radius = new float[1024];
  rot = new float[1024];
  gruen = new float[1024];
  blau = new float[1024];
  transparenz = new float[1024];//von amplitude abhängig
  staerke = new float[1024];//von amplitude abhängig 
  eckenAnzahl = new int[1024];//von amplitude abhängig
  winkel = new float[1024];//von eckenAnzahl abhängig
  //Initialisierung aller Arrays
  for(int i=0;i<1024;i++){
    mixLevel[i]=linksLevel[i]=rechtsLevel[i]=0;
    rot[i]=gruen[i]=blau[i]=0;
    amplitude[i]=radius[i]=transparenz[i]=0;
    staerke[i]=winkel[i]=0;
    eckenAnzahl[i]=0;
  
  }
  minim = new Minim(this);               
  musik = minim.loadFile ("musik.mp3");
  musik.play();                           
}

void draw() {
  
  aktuelleWerteAuslesen();
  zeileZeichnen(int(zeilenNummer));
  zeilenNummer = zeilenNummer + zAbstand;
  if(zeilenNummer >= hoehe-rand) noLoop();
}

//Bei einem draw-Takt wird eine komplette Zeile geschrieben
void zeileZeichnen(int zeilenNummer){
  this.zeilenNummer = zeilenNummer;
  for(int i=0;i<1024;i++){
    //senkrechte Striche zeichnen
    if(staerke[i] < 2.0){
        stroke(rot[i], gruen[i], blau[i], transparenz[i]*4); 
        strokeWeight(staerke[i]+0.5);
        line(i+rand, zeilenNummer+rand, i+rand, zeilenNummer+rand);
      }
      
      //Ellipsen zeichnen
      if(staerke[i] >= 2.0 && staerke[i] <2.8){
        strokeWeight(1);
        fill(rot[i],gruen[i],blau[i],transparenz[i]*0.5);
        ellipse(i+rand,zeilenNummer+rand,staerke[i]*random(5,12),staerke[i]*random(4,10));
      }
      
      //Polygone zeichnen
      if(staerke[i] >=2.8){
        if(radius[i] > 8){
          strokeWeight(1);
          stroke(rot[i], gruen[i], blau[i], transparenz[i]*4);
        }else{noStroke();}
        fill(rot[i], gruen[i], blau[i], transparenz[i]);
        pushMatrix();
        translate(i+rand, zeilenNummer+rand);
        eckenAnzahl[i] = int(amplitude[i]*amplitude[i]*1000);
        if(eckenAnzahl[i] > 8) eckenAnzahl[i] = 8;
        if(eckenAnzahl[i] < 3) eckenAnzahl[i] =3;
        winkel[i] = TWO_PI/eckenAnzahl[i]; 
        beginShape();
          for (int j=0; j<=eckenAnzahl[i]; j++) {
            float xV = 0 + cos(winkel[i]*j) * radius[i];
            float yV = 0 + sin(winkel[i]*j) * radius[i];
            vertex(xV, yV);
          }
       endShape();
       popMatrix();   
      } 
   } 
}

// Alles was aktuell im Puffer steht wird ausgelesen
void aktuelleWerteAuslesen(){
  for(int n=0;n<1024;n++){
    mixLevel[n] = musik.mix.get(int(n));
    linksLevel[n] = musik.left.get(int(n)); 
    rechtsLevel[n] = musik.right.get(int(n));
    amplitude[n] = musik.mix.level()*random(0.5,1.5);
    radius[n] = mixLevel[n]*mixLevel[n] * zAbstand * aFaktor; 
    if(radius[n] > 14) radius[n] = 14; 
    if(radius[n] <  5) radius[n] =  5; 
    rot[n] = linksLevel[n]*linksLevel[n]*30000 % 256;
    gruen[n] = mixLevel[n]*mixLevel[n]*30000 % 256;
    blau[n] = rechtsLevel[n]*rechtsLevel[n]*30000 % 256;
    transparenz[n] = amplitude[n]*1200 % 200; 
    staerke[n] = amplitude[n]*amplitude[n]*1000 % 7;             
  }
}

void keyPressed(){ 
  if (key == 's'){
    saveFrame("musikBild.jpg");
  }
  
  if(key == 'h'){
    stop();
  }
}
void stop() {
  musik.close();
  minim.stop();
  super.stop();
}